//
//  ASFacebook.h
//  ASShareSocial
//
//  Created by Lion Mac OS on 6/19/13.
//  Copyright (c) 2013 Lion Mac OS. All rights reserved.
//

#import <Foundation/Foundation.h>
@class ASFacebook;
@class ASFacebookAuthenticationToken;
@class ASFacebookWebviewControl;

@protocol ASFacebookDelegate
@required
-(void)getAccessToken:(ASFacebook *)facebook withError:(NSDictionary *)error;
-(void)getAccessTokenWindowWillShow:(ASFacebook *)facebook;
-(void)getAccessTokenWindowWillDismiss:(ASFacebook *)facebook withError:(NSDictionary *)error;
@end

@interface ASFacebook : NSObject
{
    NSString *_appID;
    id<ASFacebookDelegate> _delegate;
    ASFacebookAuthenticationToken *_authToken;
    ASFacebookWebviewControl *_webViewControl;
}

-(id)initWithAppID:(NSString *)appID delegate:(id<ASFacebookDelegate>)del;
-(BOOL)getAccessTokenForPermissions:(BOOL)bCache;
-(BOOL)getAccessTokenForPermissions:(NSArray *)perms cached:(BOOL)bCache;
-(void)invalidateCachedAccessToken;
/*
 *if success return nil, else return @vASFacebookAccessTokenError*** value; 
 *Only support 960x960px.
 */
-(NSString *)uploadPhoto:(NSString *)photo;
-(NSString *)uploadNSImage:(NSImage *)img;
-(NSString *)uploadBitmapImageRep:(NSBitmapImageRep *)bmpRep;
@end
