//
//  ASShareSocial.h
//  ASShareSocial
//
//  Created by Lion Mac OS on 6/19/13.
//  Copyright (c) 2013 Lion Mac OS. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "ASFacebook.h"
#import "ASTwitter.h"
#import "ASFlickr.h"

typedef enum
{
    ASFacebookSocial=0,
    ASTwitterSocial,
    ASFlickrSocial,
    ASTumblrSocial,
}ASSocialType;

//result
extern NSString * const kASAccessTokenValid; //NSNumber boolValue special get Access Token success or not.
extern NSString * const kASShareSocialErrorDescription; //NSString special the error.

extern NSString * const vASShareSocialErrorSucceed;
extern NSString * const vASShareSocialErrorCancelled;  //
extern NSString * const vASShareSocialErrorCannotFindHostName;
extern NSString * const vASShareSocialErrorTimeOut;
extern NSString * const vASShareSocialErrorInvalidateParameter;
extern NSString * const vASShareSocialErrorCannotConnectToHost;
extern NSString * const vASShareSocialErrorNetworkConnectionLost;
extern NSString * const vASShareSocialErrorNotConnectedToInternet;
extern NSString * const vASShareSocialErrorDNSLookupFailed;
extern NSString * const vASShareSocialErrorInvalidateAccessToken;
extern NSString * const vASShareSocialErrorUnknown;

////access token
extern NSString * const kASAccessTokenParameterSocialType; //NSNumber special social type;
extern NSString * const kASAccessTokenParameterAppID; //NSString object special app id;
extern NSString * const vASAccessTokenDefaultAppID;
extern NSString * const kASAccessTokenParameterScape; //Array object special scape.
extern NSString * const vASAccessTokenScapePublishStream;

@class ASShareSocial;
@protocol ASShareSocialDelegate <NSObject>
-(void)shareSocialGetAccessTokenComplete:(ASShareSocial *)shareSocial withResult:(NSDictionary *)result;
-(void)shareSocialWillShowAuthenticationWnd:(ASShareSocial *)shareSocial;
-(void)shareSocialAuthenticationComplete:(ASShareSocial *)shareSocial withResult:(NSDictionary *)result;
@end

@interface ASShareSocial : NSObject<ASFacebookDelegate, ASTwitterDelegate, ASFlickrDelegate >
{
    id<ASShareSocialDelegate> _delegate;
    
    ASFacebook *_facebook;
    ASTwitter *_twitter;
    ASFlickr *_flickr;
}

+(ASShareSocial *)shareSocial;
-(void)setDelegate:(id<ASShareSocialDelegate>)del;

-(BOOL)getAccessTokenWithParameter:(NSDictionary *)dic;
-(void)invalidateAccessToken:(ASSocialType)sType;
-(NSString *)uploadPhoto:(NSString *)photo toSocial:(ASSocialType)sType;
-(NSString *)uploadPhoto:(NSString *)photo toSocial:(ASSocialType)sType withDescription:(NSString *)description;
-(NSString *)uploadNSImage:(NSImage *)image toSocial:(ASSocialType)sType;
-(NSString *)uploadNSImage:(NSImage *)image toSocial:(ASSocialType)sType withDescription:(NSString *)description;
@end
