//
//  ASTwitter.h
//  ASShareSocial
//
//  Created by Lion Mac OS on 6/20/13.
//  Copyright (c) 2013 Lion Mac OS. All rights reserved.
//

#import <Foundation/Foundation.h>

@class GTMOAuthAuthentication;
@class ASTwitter;
@protocol ASTwitterDelegate <NSObject>
@required
-(void)twitterAccessTokenComplete:(ASTwitter *)twitter withResult:(NSDictionary *)result;
//-(void)twitterAccessWindowWillShow:(ASTwitter *)twitter;
-(void)twitterAuthenticationComplete:(ASTwitter *)twitter withResult:(NSDictionary *)result;
@end
@interface ASTwitter : NSObject
{
    GTMOAuthAuthentication *_auth;
    NSString *_errorCode;
    id<ASTwitterDelegate> _delegate;
}

-(id)initWithDelegate:(id<ASTwitterDelegate>)del;
-(BOOL)getAccessToken;
-(void)invalidateCachedAccessToken;
-(NSString *)uploadPhoto:(NSString *)photo withTweet:(NSString *)tweet;
-(NSString *)uploadPhoto:(NSString *)photo;
-(NSString *)uploadNSImage:(NSImage *)img;
-(NSString *)uploadNSImage:(NSImage *)img withTweet:(NSString *)tweet;
@end
